/* Copyright(C) 2011 Cobac.Net All rights reserved. */

module MYPIO(
    /* AvalonoX */
    input           CLK, RST,
    input           ADDR,
    input           WRITE, READ,
    input   [7:0]   WRDATA,
    output  [7:0]   RDDATA,
    /* |[g */
    input       [3:0]   SW,
    output  reg [7:0]   nHEX
);

/* o̓WX^ */
always @( posedge CLK, posedge RST ) begin
    if ( RST )
        nHEX <= 8'hFF;
    else if ( WRITE && ADDR==1'b0 )
        nHEX <= WRDATA;
end

/* ̓WX^ */
assign RDDATA = (READ==1'b0) ? 8'h00:
                (ADDR==1'b0) ? nHEX: {4'h0, SW};

endmodule
